/*
 * $Id$
 */

package org.apache.pluto.maven.resources.remote.io.xpp3;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.Writer;
import java.util.Iterator;
import org.apache.pluto.maven.resources.remote.RemoteResourcesBundle;
import org.codehaus.plexus.util.xml.pull.*;

/**
 * Class RemoteResourcesBundleXpp3Writer.
 * 
 * @version $Revision$ $Date$
 */
public class RemoteResourcesBundleXpp3Writer {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field serializer
     */
    private org.codehaus.plexus.util.xml.pull.XmlSerializer serializer;

    /**
     * Field NAMESPACE
     */
    private String NAMESPACE;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method write
     * 
     * @param writer
     * @param remoteResourcesBundle
     */
    public void write(Writer writer, RemoteResourcesBundle remoteResourcesBundle)
        throws java.io.IOException
    {
        serializer = new MXSerializer();
        serializer.setProperty( "http://xmlpull.org/v1/doc/properties.html#serializer-indentation", "  " );
        serializer.setProperty( "http://xmlpull.org/v1/doc/properties.html#serializer-line-separator", "\n" );
        serializer.setOutput( writer );
        serializer.startDocument( remoteResourcesBundle.getModelEncoding(), null );
        writeRemoteResourcesBundle( remoteResourcesBundle, "remoteResourcesBundle", serializer );
        serializer.endDocument();
    } //-- void write(Writer, RemoteResourcesBundle) 

    /**
     * Method writeRemoteResourcesBundle
     * 
     * @param remoteResourcesBundle
     * @param serializer
     * @param tagName
     */
    private void writeRemoteResourcesBundle(RemoteResourcesBundle remoteResourcesBundle, String tagName, XmlSerializer serializer)
        throws java.io.IOException
    {
        if ( remoteResourcesBundle != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( remoteResourcesBundle.getRemoteResources() != null && remoteResourcesBundle.getRemoteResources().size() > 0 )
            {
                serializer.startTag( NAMESPACE, "remoteResources" );
                for ( Iterator iter = remoteResourcesBundle.getRemoteResources().iterator(); iter.hasNext(); )
                {
                    String remoteResource = (String) iter.next();
                    serializer.startTag( NAMESPACE, "remoteResource" ).text( remoteResource ).endTag( NAMESPACE, "remoteResource" );
                }
                serializer.endTag( NAMESPACE, "remoteResources" );
            }
            if ( remoteResourcesBundle.getResourceSupplements() != null && remoteResourcesBundle.getResourceSupplements().size() > 0 )
            {
                serializer.startTag( NAMESPACE, "resourceSupplements" );
                for ( Iterator iter = remoteResourcesBundle.getResourceSupplements().iterator(); iter.hasNext(); )
                {
                    String resourceSupplement = (String) iter.next();
                    serializer.startTag( NAMESPACE, "resourceSupplement" ).text( resourceSupplement ).endTag( NAMESPACE, "resourceSupplement" );
                }
                serializer.endTag( NAMESPACE, "resourceSupplements" );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeRemoteResourcesBundle(RemoteResourcesBundle, String, XmlSerializer) 

}
